#include "uart.h"
#define F_CPU 16000000UL

#if defined(_AVR_IOM8_H_)
	#define _UBRRL	UBRRL
	#define _UCSRB	UCSRB
	#define _UCSRC	UCSRC
	#define _TXEN	TXEN
	#define _RXEN	RXEN
	#define _UCSZ1	UCSZ1
	#define _UCSZ0	UCSZ0
	#define _UDR	UDR
	#define _UCSRB	UCSRB
	#define _RXCIE	RXCIE
	#define _UCSRA	UCSRA
	#define _UDRE	UDRE
	#define _SETTING	UCSRC |= (1 << URSEL) | (1 << UCSZ1) | (1 << UCSZ0);	
#elif defined(_AVR_IOM168P_H_)
	#define _UBRRL	UBRR0L
	#define _UCSRB	UCSR0B
	#define _UCSRC	UCSR0C
	#define _TXEN	TXEN0
	#define _RXEN	RXEN0
	#define _UCSZ1	UCSZ01
	#define _UCSZ0	UCSZ00
	#define _UDR	UDR0
	#define _UCSRB	UCSR0B
	#define _RXCIE	RXCIE0
	#define _UCSRA	UCSR0A
	#define _UDRE	UDRE0
	#define _SETTING	_UCSRC |= (1 << _UCSZ1) | (1 << _UCSZ0);
#endif

void uart_init(void)
{
	uint8_t x;
		   	 
//	_UBRRL = ((F_CPU + UART_BAUD * 8) / ( UART_BAUD * 16 ) - 1);

	_UBRRL = (F_CPU / (16ul * UART_BAUD))-1;					// Baudrate mit Takt und Baud

	_UCSRB |= (1 << _TXEN);				 						// Sender und Empnger aktivieren
	_SETTING;													// Async 8bit
	
	x = _UDR;													// Empfnger leeren
	sbi(_UCSRB,_RXCIE);											// USART-Empfangs-Interrupt aktivieren
}

void uart_send_byte(uint8_t x)
{
	while(!(_UCSRA & (1 << _UDRE)));							// warten bis Schnittstelle bereit
	_UDR = x;													// Zu sendendes Byte bergeben
}

void uart_send_text(char *s)
{
    while (*s)													// so lange *s ungleich '\0' (String-Endezeichen)
    {   
        uart_send_byte(*s);										// Byte senden
        s++;													// nchstes Byte whlen
    }
}
